import { select, csvParse } from 'd3';

export const viz = (container, options) => {
  const [state, setState] = options;
  const { data } = state;

  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(data, null, 2));

  if (!data) {
    setState((prev) => ({ ...prev, data: 'LOADING' }));

    fetch('data.csv')
      .then((res) => res.text())
      .then((csvString) => {
        const data = csvParse(csvString);

        data.forEach((d) => {
          (d.sepal_length = +d.sepal_length),
            (d.sepal_width = +d.sepal_width),
            (d.petal_width = +d.petal_width),
            (d.petal_length = +d.petal_length);
        });

        setState((prev) => ({ ...prev, data: data }));
      });
  }
};
